<?php
/*
**********************************************************
*        Awards System
*        Version: 1.1
**********************************************************
*        DISCLAIMER
*        This program is free software; you can redistribute it and/or modify
*        it under the terms of the GNU General Public License as published by
*        the Free Software Foundation; either version 2 of the License, or
*        (at your option) any later version.
*        We are not responsible for any damages that this program can cause
*        to your system.
*        It may be used and modified free of charge, as long as the copyright notice
*        in the program that give me credit remain intact.
*        Selling this script is absolutely forbidden and illegal.
**********************************************************
*/

define('X_SCRIPT', 'awedit.php');
require('header.php');

loadtemplates('');

nav($lang['awardsadmin']);

eval('$css = "'.template('css').'";');

$threadSubject = $lang['awardssystem'];

switch($action) {
case 'viewawards':
    eval('echo "'.template('header').'";');

    $query = $db->query("SELECT * FROM ".X_PREFIX."awards");
    ?>
    <table cellspacing="0" cellpadding="0" border="0" width="100%" align="center">
    <tr><td bgcolor="<?php echo $bordercolor; ?>">
    <table border="0" cellspacing="<?php echo $borderwidth; ?>" cellpadding="<?php echo $tablespace; ?>" width="400">
    <tr><td bgcolor="<?php echo $altbg1; ?>" colspan="3" class="header"><?php echo $lang['availableawards4']; ?> <?php echo $bbname; ?></td></tr>
    <?php
    while($award = $db->fetch_array($query)) {
        echo '<tr class="tablerow"><td bgcolor="', $altbg1, '" width="2%"><img src="images/awards/', $award['awimgurl'], '" align="middle" border="0" /></td><td bgcolor="', $altbg2, '" align="center" width="25%">', $award['awname'], '</td><td bgcolor="', $altbg1, '"> ', $award['awdesc'], "</td></tr>\n";
    }
    $db->free_result($query);
    ?>
    </table>
    </td>
    </tr>
    </table>
    <?php
break;
case 'edit':
    if (!X_ADMIN) {
        eval('$notadmin = "'.template('error_nologinsession').'";');
        error($notadmin);
    }

    $username = postedVar('username', '', TRUE, FALSE, FALSE, 'g');
    $encodeduser = recodeOut($username);
    $dbuser = $db->escape($username);

    if (onSubmit('editawards')) {
        request_secure('editawardshk', '', X_NONCE_FORM_EXP);

        $awardstring = '';
        foreach($_POST as $key => $val) {
            if (is_numeric($val) and $key != 'token') {
                $awardstring .= '['.$val.']';
            }
        }

        $db->query("UPDATE ".X_PREFIX."members SET awards='$awardstring' WHERE username='$dbuser'");
        $msg = '<center><span class="mediumtxt">'.$lang['awardsupdate4'].' '.$username.'</span></center>';
        $redirect = "{$full_url}awedit.php?action=edit&username=$encodeduser";
        message($msg, TRUE, '', '', $redirect);
    }

    eval('echo "'.template('header').'";');

    $query = $db->query("SELECT * FROM ".X_PREFIX."awards");
    $awardnum = $db->num_rows($query, 0);
    $awardcache = array();
    $currawards = '';
    while ($award = $db->fetch_array($query)) {
        $awardcache[$award['awid']] = '<tr class="tablerow"><td bgcolor="'.$altbg1.'" width="2%"><input type="checkbox" name="awid'.$award['awid'].'" value="'.$award['awid'].'" checked="checked" /></td><td bgcolor="'.$altbg2.'" align="center" width="10%"><img src="./images/awards/'.$award['awimgurl'].'" align="middle" border="0" alt="'.$award['awname'].': '.$award['awdesc'].'" /></td><td bgcolor="'.$altbg1.'" class="header">'.$award['awname'].': '.$award['awdesc']."</td></tr>\n";
        $currawards .=                '<tr class="tablerow"><td bgcolor="'.$altbg1.'" width="2%"><input type="checkbox" name="awid'.$award['awid'].'" value="'.$award['awid'].'"                   /></td><td bgcolor="'.$altbg2.'" align="center"            ><img src="images/awards/'.$award['awimgurl'].'"   align="middle" border="0" alt="'.$award['awname'].': '.$award['awdesc'].'" /></td><td bgcolor="'.$altbg1.'" class="header">'.$award['awname'].': '.$award['awdesc']."</td></tr>\n";
    }
    $db->free_result($query);

    $query = $db->query("SELECT username, awards FROM ".X_PREFIX."members WHERE username='$dbuser'");
    $memberinfo = $db->fetch_array($query);
    $db->free_result($query);
    //you can uncomment this part if you don't want Admins/SM getting awards
    /*if ($db->escape($memberinfo['username']) == $xmbuser) {
        echo '<center><span class="mediumtxt">$lang[noaward]</span></center>';
        exit;
    }*/

    $showawards = $memberinfo['awards'];
    if ($showawards != '') {
        foreach ($awardcache as $key => $value) {
            $showawards = str_replace('['.$key.']', $value, $showawards);
        }
        $showawards .= "<tr><td bgcolor='$altbg1' colspan='3' class='tablerow'>{$lang['delaward']}</td></tr>";
    } else {
        $showawards = "<tr class='tablerow'><td bgcolor='$altbg2' colspan='3' class='header'>{$lang['noawards']}</td></tr>";
    }
    ?>
    <form method="post" action="awedit.php?action=edit&amp;username=<?php echo $encodeduser; ?>">
    <input type="hidden" name="token" value="<?php echo nonce_create('editawardshk'); ?>" />
    <table cellspacing="0" cellpadding="0" border="0" width="400" align="center">
    <tr><td bgcolor="<?php echo $bordercolor; ?>">
    <table border="0" cellspacing="<?php echo $borderwidth; ?>" cellpadding="<?php echo $tablespace; ?>" width="100%">
    <tr>
    <td colspan="3" class="category"><?php echo $lang['awards4']; ?> <?php echo $username; ?></td>
    </tr>
    <?php echo $showawards; ?>
    <tr>
    <td bgcolor="<?php echo $altbg1; ?>" colspan="3" class="category"><?php echo $lang['availableawards']; ?></td>
    </tr>
    <?php echo $currawards; ?>
    <tr>
    <td bgcolor="<?php echo $altbg1; ?>" colspan="3" class="tablerow"> <?php echo $lang['addaward']; ?></td>
    </tr>
    </table>
    </td></tr>
    </table>
    <br />
    <center><input type="submit" name="editawards" class="submit" value="Submit" /></center>
    </form><br />
    <center>
    <span class="mediumtxt"><a href="awedit.php?action=addawards" onclick="window.open(this.href); return false;"><b><?php echo $lang['awardsadminpanel']; ?></b></a>
    </span>
    </center>
    <?php
break;
case 'addawards':
    if (!X_ADMIN) {
        eval('$notadmin = "'.template('error_nologinsession').'";');
        error($notadmin);
    }

    if (onSubmit('awardsupsubmit')) {
        request_secure('addawardshak', '', X_NONCE_FORM_EXP);
        require ROOT.'include/attach.inc.php';

        $newawname = postedVar('newawname', 'javascript', TRUE, TRUE, TRUE);
        $newawdesc = postedVar('newawdesc', 'javascript', TRUE, TRUE, TRUE);
        $rawawname = postedVar('newawname', 'javascript', TRUE, FALSE);

        $attach_name = '';
        $filetype = '';
        $filesize = 0;
        $result = get_attached_file('attach', $attach_name, $filetype, $filesize, FALSE, FALSE);
        if (FALSE === $result) {
            error($attachmentErrors[$filetype]);
        }

        move_uploaded_file($_FILES['attach']['tmp_name'], "./images/awards/$attach_name");

        $attach_name = htmlspecialchars($attach_name, ENT_QUOTES);
        $db->escape_fast($attach_name);
        $db->query("INSERT INTO ".X_PREFIX."awards SET awname='$newawname', awdesc='$newawdesc', awimgurl='$attach_name'");
        $msg = "<center><span class='mediumtxt'><strong>Award:</strong>&nbsp; $rawawname Uploaded!</span></center>";
        $redirect = "{$full_url}awedit.php?action=addawards";
        message($msg, TRUE, '', '', $redirect);
    } elseif (onSubmit('awardssubmit')) {
        request_secure('addawardshak', '', X_NONCE_FORM_EXP);

        $newawname   = postedArray('awname',   'string', 'javascript', TRUE, TRUE, TRUE);
        $newawdesc   = postedArray('awdesc',   'string', 'javascript', TRUE, TRUE, TRUE);
        $newawimgurl = postedArray('awimgurl', 'string', 'javascript', TRUE, TRUE, TRUE);
        $delete      = postedArray('delete',   'int');

        $query = $db->query("SELECT awid, awimgurl FROM ".X_PREFIX."awards");
        while ($awards = $db->fetch_array($query)) {
            if (isset($delete[$awards['awid']]) and intval($awards['awid']) === $delete[$awards['awid']]) {
                @unlink('./images/awards/'.htmlspecialchars_decode($awards['awimgurl'], ENT_QUOTES));
                $db->query("DELETE FROM ".X_PREFIX."awards WHERE awid={$awards['awid']}");
                continue;
            }

            $awname = $newawname[$awards['awid']];
            $awimgurl = $newawimgurl[$awards['awid']];
            $awdesc = $newawdesc[$awards['awid']];

            $db->query("UPDATE ".X_PREFIX."awards SET awname='$awname', awimgurl='$awimgurl', awdesc='$awdesc' WHERE awid={$awards['awid']}");
        }
        $db->free_result($query);

        $msg = '<center><span class="mediumtxt">'.$lang['awardsupdate'].'</span></center>';
        $redirect = "{$full_url}awedit.php?action=addawards";
        message($msg, TRUE, '', '', $redirect);
    } else {
        eval('echo "'.template('header').'";');

        $nonce = nonce_create('addawardshak');
        ?>
        <form method="post" action="awedit.php?action=addawards">
        <input type="hidden" name="token" value="<?php echo $nonce; ?>" />
        <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
        <tr><td bgcolor="<?php echo $bordercolor?>">
        <table border="0" cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" width="100%">
        <tr class="header">
        <td colspan="5" <?php echo $catbgcode; ?> class="category"><font color="<?php echo $cattext?>"><?php echo $lang['awardsadminpanel']?></font></td></tr>
        <tr class="header">
        <td><img src="./images/awards/delete.gif" alt="Red X" /><br />Delete?</td>
        <td valign="bottom" align="center">Image</td>
        <td valign="bottom">Name</td>
        <td valign="bottom">Image Name</td>
        <td valign="bottom">Description</td>
        </tr>
        <?php
        $query = $db->query("SELECT * FROM ".X_PREFIX."awards ORDER BY awid");
        while ($award = $db->fetch_array($query)) {
            ?>
            <tr bgcolor="<?php echo $altbg2?>" class="tablerow">
            <td width="5%"><input type="checkbox" name="delete[<?php echo $award['awid']; ?>]" value="<?php echo $award['awid']?>" /></td>
            <td><img src="./images/awards/<?php echo $award['awimgurl']?>" alt="" /></td>
            <td><input type="text" class="text" name="awname[<?php echo $award['awid']; ?>]" value="<?php echo $award['awname']?>" size="25" /></td>
            <td><input type="text" class="text" name="awimgurl[<?php echo $award['awid']; ?>]" value="<?php echo $award['awimgurl']?>" size="15" /></td>
            <td><input type="text" class="text" name="awdesc[<?php echo $award['awid']; ?>]" value="<?php echo $award['awdesc']?>" size="55" /></td>
            </tr>
            <?php
        }
        $db->free_result($query);
        ?>
        </table>
        </td></tr>
        </table>
        <center><input type="submit" class="submit" name="awardssubmit" value="Submit" /></center>
        </form>

        <br />

        <form enctype="multipart/form-data" method="post" action="awedit.php?action=addawards">
        <input type="hidden" name="token" value="<?php echo $nonce; ?>" />
        <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
        <tr><td bgcolor="<?php echo $bordercolor?>">
        <table border="0" cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" width="100%">
        <tr class="header">
         <td colspan="3" <?php echo $catbgcode; ?> class="category"><font color="<?php echo $cattext?>"><?php echo $lang['uploadaward']?></font></td>
        </tr>
        <tr class="header">
         <td>Name</td>
         <td>Image</td>
         <td>Description</td>
        </tr>
        <tr bgcolor="<?php echo $altbg2?>" class="tablerow">
         <td><input type="text" class="text" name="newawname" value="" size="25" /></td>
         <td>
          <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $SETTINGS['maxattachsize']; ?>" />
          <input type="file" name="attach" value="" size="20" class="file" />
         </td>
         <td><input type="text" class="text" name="newawdesc" value="" size="55" /></td>
        </tr>
        </table>
        </td></tr></table>
        <center><input type="submit" class="submit" name="awardsupsubmit" value="Upload" /></center>
        </form>
        <?php
    }
break;
default:
    header('HTTP/1.0 404 Not Found');
    error($lang['textnoaction']);
} // switch($action)

echo '<br /><center><font class="smalltxt"><b>Awards System Hack</b><br />Created for XMB By Comicraft, GuldantheWarlock, John Briggs, Robert Chapin, Warrior, and WormHole</font></center>';

end_time();
eval('$footer = "'.template('footer').'";');
echo $footer;
?>
